Attribute VB_Name = "Mdulo1"
Option Explicit
 
Sub Actualizar()
    Call Paso_1
    Call Paso_2
    Call Paso_3
End Sub
 
' </> -------------------------------------------------------------------- </>
' </> ---&--- Arregla la presentacin de la hoja Madre
' </> -------------------------------------------------------------------- </>
 
Private Sub Paso_1()
    Columns("A:F").Select
    With Selection
        .HorizontalAlignment = xlCenter
        .VerticalAlignment = xlCenter
        .WrapText = False
        .Orientation = 0
        .AddIndent = False
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = xlContext
        .MergeCells = False
    End With
 
    Range("A1:F1").Select
    With Selection.Interior
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
        .Color = 65535
        .TintAndShade = 0
        .PatternTintAndShade = 0
    End With
 
    Selection.Font.Bold = True
    Columns("A:A").EntireColumn.AutoFit
    Columns("B:B").EntireColumn.AutoFit
    Range("A2").Select
 
    ' ---&--- Inmoviliza la fila 1
 
    With ActiveWindow
        .SplitColumn = 0
        .SplitRow = 1
    End With
    ActiveWindow.FreezePanes = True
End Sub
 
' </> -------------------------------------------------------------------- </>
' </> ---&--- Ordena la hoja Madre por Tipo + Via + Fecha
' </> -------------------------------------------------------------------- </>
 
Private Sub Paso_2()
    Dim Fila As Long
    Fila = 1
    While Cells(Fila, "A") <> Empty
        Fila = Fila + 1
    Wend
 
    Columns("A:F").Select
    ActiveWorkbook.Worksheets("madre").Sort.SortFields.Clear
    ActiveWorkbook.Worksheets("madre").Sort.SortFields.Add2 _
                                       Key:=Range("D2:D" & Fila), _
                                       SortOn:=xlSortOnValues, _
                                       Order:=xlAscending, _
                                       DataOption:=xlSortNormal
 
    ActiveWorkbook.Worksheets("madre").Sort.SortFields.Add2 _
                                       Key:=Range("E2:E" & Fila), _
                                       SortOn:=xlSortOnValues, _
                                       Order:=xlAscending, _
                                       DataOption:=xlSortNormal
 
    ActiveWorkbook.Worksheets("madre").Sort.SortFields.Add2 _
                                       Key:=Range("B2:B" & Fila), _
                                       SortOn:=xlSortOnValues, _
                                       Order:=xlAscending, _
                                       DataOption:=xlSortTextAsNumbers
 
    With ActiveWorkbook.Worksheets("madre").Sort
        .SetRange Range("A1:F" & Fila)
        .Header = xlYes
        .MatchCase = False
        .Orientation = xlTopToBottom
        .SortMethod = xlPinYin
        .Apply
    End With
End Sub
 
' </> -------------------------------------------------------------------- </>
' </> ---&--- Copia los datos de la hoja Madre a las hoja Tipo + Via
' </> -------------------------------------------------------------------- </>
 
Private Sub Paso_3()
    Dim Fila_Orig As Long, Antes As String, Hoja As String, Colu As String, _
        Fila_Dest As Long, A As Byte
 
    Fila_Orig = 2
    Antes = ""
    While Cells(Fila_Orig, "A") <> Empty
        Hoja = Cells(Fila_Orig, "D") & "-" & Cells(Fila_Orig, "E")
 
        ' ---&--- Creo una hoja nueva
 
        If Hoja <> Antes Then
            Sheets.Add After:=Sheets(Sheets.Count)
            Sheets(Sheets.Count).Name = Hoja
 
            For A = 1 To 6
                Colu = Mid("ABCDEFG", A, 1) & ":" & Mid("ABCDEFG", A, 1)
                Sheets(Hoja).Cells(1, A) = Sheets("Madre").Cells(1, A)
                Sheets(Hoja).Columns(Colu).ColumnWidth = Sheets("Madre").Columns(Colu).ColumnWidth
            Next
 
            Sheets(Hoja).Select: Call Paso_1
            Sheets("Madre").Select
 
            Fila_Dest = 2
            Antes = Hoja
        End If
 
        ' ---&--- Copia los datos de la hoja madre a la hoja Tipo + Via
 
        For A = 1 To 6
            Sheets(Hoja).Cells(Fila_Dest, A) = Sheets("Madre").Cells(Fila_Orig, A)
        Next
 
        Fila_Orig = Fila_Orig + 1
        Fila_Dest = Fila_Dest + 1
    Wend
End Sub

